###################################################
### chunk number 1: prelim
###################################################
#line 601 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
options(prompt="R> ")
library("clValid")


###################################################
### chunk number 2: mouse
###################################################
#line 608 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
data(mouse)


###################################################
### chunk number 3: internal
###################################################
#line 647 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
express <- mouse[,c("M1","M2","M3","NC1","NC2","NC3")]
rownames(express) <- mouse$ID
intern <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
                  validation="internal")


###################################################
### chunk number 4: 
###################################################
#line 660 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
summary(intern)


###################################################
### chunk number 5: internPlot
###################################################
#line 675 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
op <- par(no.readonly=TRUE)
par(mfrow=c(2,2),mar=c(4,4,3,1))
plot(intern, legend=FALSE)
plot(nClusters(intern),measures(intern,"Dunn")[,,1],type="n",axes=F,
        xlab="",ylab="")
legend("center", clusterMethods(intern), col=1:9, lty=1:9, pch=paste(1:9))
par(op)


###################################################
### chunk number 6: 
###################################################
#line 687 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 675 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#687#"
op <- par(no.readonly=TRUE)
par(mfrow=c(2,2),mar=c(4,4,3,1))
plot(intern, legend=FALSE)
plot(nClusters(intern),measures(intern,"Dunn")[,,1],type="n",axes=F,
        xlab="",ylab="")
legend("center", clusterMethods(intern), col=1:9, lty=1:9, pch=paste(1:9))
par(op)
#line 688 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 7: stability
###################################################
#line 716 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
stab <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
                validation="stability")


###################################################
### chunk number 8: optimal
###################################################
#line 725 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
optimalScores(stab)


###################################################
### chunk number 9: stabPlot
###################################################
#line 739 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
par(mfrow=c(2,2),mar=c(4,4,3,1))
plot(stab, measure=c("APN","AD","ADM"),legend=FALSE)
plot(nClusters(stab),measures(stab,"APN")[,,1],type="n",axes=F,
        xlab="",ylab="")
legend("center", clusterMethods(stab), col=1:9, lty=1:9, pch=paste(1:9))
par(op)


###################################################
### chunk number 10: 
###################################################
#line 750 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 739 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#750#"
par(mfrow=c(2,2),mar=c(4,4,3,1))
plot(stab, measure=c("APN","AD","ADM"),legend=FALSE)
plot(nClusters(stab),measures(stab,"APN")[,,1],type="n",axes=F,
        xlab="",ylab="")
legend("center", clusterMethods(stab), col=1:9, lty=1:9, pch=paste(1:9))
par(op)
#line 751 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 11: biological
###################################################
#line 795 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
fc <- tapply(rownames(express),mouse$FC, c)
fc <- fc[!names(fc)%in%c("EST","Unknown")]
bio <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
               validation="biological", annotation=fc)


###################################################
### chunk number 12: readExternalBiological
###################################################
#line 819 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
fc2 <- readAnnotationFile("fc.csv")
## bio.fc2 <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
##                    validation="biological", annotation=fc2)
## all.equal(measures(bio), measures(bio.fc2))


###################################################
### chunk number 13: bioOptimal
###################################################
#line 827 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
optimalScores(bio)


###################################################
### chunk number 14: BHI
###################################################
#line 836 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
plot(bio, measure="BHI", legendLoc="topleft")


###################################################
### chunk number 15: BSI
###################################################
#line 841 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
plot(bio, measure="BSI")


###################################################
### chunk number 16: 
###################################################
#line 847 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 836 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#847#"
plot(bio, measure="BHI", legendLoc="topleft")
#line 848 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 17: 
###################################################
#line 857 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 841 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#857#"
plot(bio, measure="BSI")
#line 858 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 18: bioc
###################################################
#line 895 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
if(require("Biobase") && require("annotate") && require("GO.db") && require("moe430a.db")) {
  ## Need to know which affy chip was used in experiment
  ## affymetrix murine genome 430a genechip arrays
  bio2 <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
                  validation="biological",annotation="moe430a.db",GOcategory="all")
}



###################################################
### chunk number 19: 
###################################################
#line 905 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
if(exists("bio2")) optimalScores(bio2)


###################################################
### chunk number 20: BHI2
###################################################
#line 917 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
if(exists("bio2")) plot(bio2, measure="BHI", legendLoc="topleft")


###################################################
### chunk number 21: BSI2
###################################################
#line 921 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
if(exists("bio2")) plot(bio2, measure="BSI")


###################################################
### chunk number 22: 
###################################################
#line 927 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 917 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#927#"
if(exists("bio2")) plot(bio2, measure="BHI", legendLoc="topleft")
#line 928 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 23: 
###################################################
#line 937 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 921 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#937#"
if(exists("bio2")) plot(bio2, measure="BSI")
#line 938 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 24: biocDE eval=FALSE
###################################################
## #line 951 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
## if(require("Biobase") && require("annotate") && require("GO.db") && require("moe430a.db")) {
##   ## Need to know which affy chip was used in experiment
##   ## affymetrix murine genome 430a genechip arrays
##   bio2DE <- clValid(express, 2:6, clMethods=c("hierarchical","kmeans","pam"),
##                   validation="biological",annotation="moe430a.db",GOcategory="all",
##                   dropEvidence="IEA")
##   optimalScores(bio2DE)
## }


###################################################
### chunk number 25: RankAggreg
###################################################
#line 985 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
result <- clValid(express, 4:6, clMethods=c("hierarchical","kmeans","pam"), 
                  validation=c("internal","stability"))
res <- getRanksWeights(result)


###################################################
### chunk number 26: ranks
###################################################
#line 997 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
print(res$ranks[,1:3], quote=FALSE)


###################################################
### chunk number 27: RankAggreg
###################################################
#line 1019 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
if(require("RankAggreg")) {
  CEWS <- RankAggreg(x=res$ranks, k=5, weights=res$weights, seed=123, verbose=FALSE)
  CEWS
}


###################################################
### chunk number 28: RankAggFig
###################################################
#line 1039 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
plot(CEWS)


###################################################
### chunk number 29: RAFig
###################################################
#line 1044 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 1039 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#1044#"
plot(CEWS)
#line 1045 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 30: hierarchical
###################################################
#line 1082 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
hc <- clusters(bio,"hierarchical")


###################################################
### chunk number 31: hplot
###################################################
#line 1086 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
mfc <- factor(mouse$FC, labels=c("Re","EST","GD","KP","Met","Mis","St","TF","U"))
tf.gd <- ifelse(mfc%in%c("GD","TF"),levels(mfc)[mfc],"")
plot(hc, labels=tf.gd, cex=0.7, hang=-1, main="Mouse Cluster Dendrogram")


###################################################
### chunk number 32: 
###################################################
#line 1094 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
#line 1086 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw#from line#1094#"
mfc <- factor(mouse$FC, labels=c("Re","EST","GD","KP","Met","Mis","St","TF","U"))
tf.gd <- ifelse(mfc%in%c("GD","TF"),levels(mfc)[mfc],"")
plot(hc, labels=tf.gd, cex=0.7, hang=-1, main="Mouse Cluster Dendrogram")
#line 1095 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"


###################################################
### chunk number 33: twoClusters
###################################################
#line 1101 "d:/Rcompile/CRANpkg/local/2.12/clValid/inst/doc/clValid.Rnw"
two <- cutree(hc,2)
xtabs(~mouse$FC + two)


